diff --git a/.gitignore b/.gitignore
index da06ac0..3e25eec 100644
--- a/.gitignore
+++ b/.gitignore
@@ -11,5 +11,10 @@ package-lock.json
 clib-build
 clib-update
 clib-upgrade
+
 test/package/package-*
 !test/package/package-*.c
+
+test/cache/*
+!test/cache/*.c
+!test/cache/Makefile
diff --git a/Makefile b/Makefile
index 27f3ec0..793e18f 100644
--- a/Makefile
+++ b/Makefile
@@ -58,6 +58,8 @@ clean:
 	$(foreach c, $(BINS), $(RM) $(c);)
 	$(RM) $(OBJS)
 	$(RM) $(AUTODEPS)
+	cd test/cache && make clean
+	cd test/package && make clean
 
 install: $(BINS)
 	$(MKDIR) $(PREFIX)/bin
diff --git a/clib.json b/clib.json
index 18d4a34..8c96302 100644
--- a/clib.json
+++ b/clib.json
@@ -30,18 +30,17 @@
     "clibs/parson": "1.0.2",
     "clibs/http-get.c": "*",
     "hash": "0.0.1",
-
     "list": "*",
     "stephenmathieson/substr.c": "0.1.2",
     "stephenmathieson/mkdirp.c": "0.1.5",
     "stephenmathieson/path-join.c": "0.0.6",
     "stephenmathieson/parse-repo.c": "1.1.1",
     "stephenmathieson/debug.c": "0.0.0",
-    "clib-cache": "0.2.0",
-    "stephenmathieson/tempdir.c": "0.0.2"
+    "stephenmathieson/tempdir.c": "0.0.2",
+    "isty001/copy": "0.0.0",
+    "stephenmathieson/rimraf.c": "0.1.0"
   },
   "development": {
-    "stephenmathieson/describe.h": "2.0.1",
-    "stephenmathieson/rimraf.c": "0.1.0"
+    "stephenmathieson/describe.h": "2.0.1"
   }
 }
diff --git a/deps/clib-cache/clib.json b/deps/clib-cache/clib.json
deleted file mode 100644
index e021e5e..0000000
--- a/deps/clib-cache/clib.json
+++ /dev/null
@@ -1,25 +0,0 @@
-{
-  "name": "clib-cache",
-  "description": "Caching for clib packages",
-  "version": "0.2.0",
-  "repo": "clibs/clib-cache",
-  "dependencies": {
-    "isty001/copy": "0.0.0",
-    "jwerle/fs.c": "0.2.0",
-    "stephenmathieson/mkdirp.c": "0.1.5",
-    "stephenmathieson/rimraf.c": "0.1.0"
-  },
-  "development": {
-    "jlcordeiro/minunit": "*"
-  },
-  "keywords": [
-    "clib",
-    "cache",
-    "package"
-  ],
-  "src": [
-    "src/cache.h",
-    "src/cache.c"
-  ],
-  "license": "MIT"
-}
\ No newline at end of file
diff --git a/deps/commander/clib.json b/deps/commander/clib.json
new file mode 100644
index 0000000..b601ca7
--- /dev/null
+++ b/deps/commander/clib.json
@@ -0,0 +1,9 @@
+{
+  "name": "commander",
+  "version": "1.3.2",
+  "repo": "clibs/commander",
+  "description": "Command-line argument parser",
+  "keywords": ["cli", "command", "parser", "argv", "args", "options"],
+  "license": "MIT",
+  "src": ["src/commander.h", "src/commander.c"]
+}
diff --git a/deps/copy/clib.json b/deps/copy/clib.json
new file mode 100644
index 0000000..a707952
--- /dev/null
+++ b/deps/copy/clib.json
@@ -0,0 +1,26 @@
+{
+  "name": "copy",
+  "description": "Copies files, directories recursively",
+  "version": "0.0.0",
+  "repo": "Isty001/copy",
+  "dependencies": {
+    "cxong/tinydir": "*",
+    "jwerle/fs.c": "0.1.2"
+  },
+  "development": {
+    "jlcordeiro/minunit": "*",
+    "stephenmathieson/rimraf.c": "0.1.0"
+  },
+  "keywords": [
+    "dir",
+    "directory",
+    "file",
+    "copy",
+    "recursive"
+  ],
+  "license": "MIT",
+  "src": [
+    "src/copy.c",
+    "src/copy.h"
+  ]
+}
diff --git a/deps/fs/package.json b/deps/fs/package.json
new file mode 100644
index 0000000..5075fdf
--- /dev/null
+++ b/deps/fs/package.json
@@ -0,0 +1,22 @@
+{
+  "name": "fs",
+  "version": "0.1.2",
+  "description": "File system API much like Node's fs module",
+  "repo": "jwerle/fs.c",
+  "src": ["fs.h", "fs.c"],
+  "scripts": {
+    "test": "make test"
+  },
+  "repository": {
+    "type": "git",
+    "url": "git@github.com:jwerle/fs.c.git"
+  },
+  "keywords": [
+    "fs"
+  ],
+  "author": "Joseph Werle",
+  "license": "MIT",
+  "bugs": {
+    "url": "https://github.com/jwerle/fs.c/issues"
+  }
+}
diff --git a/deps/hash/clib.json b/deps/hash/clib.json
new file mode 100644
index 0000000..1b3d49e
--- /dev/null
+++ b/deps/hash/clib.json
@@ -0,0 +1,9 @@
+{
+  "name": "hash",
+  "version": "0.0.1",
+  "repo": "clibs/hash",
+  "description": "Hash wrapper around khash",
+  "keywords": ["hash", "khash", "container"],
+  "license": "MIT",
+  "src": ["hash.c", "hash.h", "khash.h"]
+}
\ No newline at end of file
diff --git a/deps/logger/clib.json b/deps/logger/clib.json
new file mode 100644
index 0000000..c7d1bba
--- /dev/null
+++ b/deps/logger/clib.json
@@ -0,0 +1,9 @@
+{
+  "name": "logger",
+  "version": "0.0.1",
+  "repo": "clibs/logger",
+  "src": ["logger.h"],
+  "dependencies": {
+    "Constellation/console-colors.c": "1.0.1"
+  }
+}
diff --git a/deps/parson/clib.json b/deps/parson/clib.json
new file mode 100644
index 0000000..ee9265c
--- /dev/null
+++ b/deps/parson/clib.json
@@ -0,0 +1,12 @@
+{
+  "name": "parson",
+  "version": "1.0.2",
+  "repo": "clibs/parson",
+  "description": "Small json parser and reader",
+  "keywords": [ "json", "parser" ],
+  "license": "MIT",
+  "src": [
+    "parson.c",
+    "parson.h"
+  ]
+}
diff --git a/deps/str-concat/clib.json b/deps/str-concat/clib.json
new file mode 100644
index 0000000..957032a
--- /dev/null
+++ b/deps/str-concat/clib.json
@@ -0,0 +1,13 @@
+
+{
+  "name": "str-concat",
+  "version": "0.0.2",
+  "repo": "darthtrevino/str-concat",
+  "description": "Returns the malloc'ed result of two c-strings concatenated.",
+  "keywords": [ "string", "concat" ],
+  "license": "MIT",
+  "src": [
+    "src/str-concat.c",
+    "src/str-concat.h"
+  ]
+}
diff --git a/deps/strdup/clib.json b/deps/strdup/clib.json
new file mode 100644
index 0000000..8da5c14
--- /dev/null
+++ b/deps/strdup/clib.json
@@ -0,0 +1,12 @@
+{
+  "name": "strdup",
+  "version": "0.1.5",
+  "repo": "clibs/strdup",
+  "description": "drop-in replacement for strdup(3) from libc",
+  "keywords": [ "string", "copy" ],
+  "license": "Expat",
+  "src": [
+    "strdup.c",
+    "strdup.h"
+  ]
+}
diff --git a/deps/strdup/strdup.c b/deps/strdup/strdup.c
index 35ea993..f34bd5d 100644
--- a/deps/strdup/strdup.c
+++ b/deps/strdup/strdup.c
@@ -12,12 +12,24 @@
 #include <string.h>
 #include "strdup.h"
 
+#ifndef strdup
+
 char *
 strdup(const char *str) {
+  if (NULL == (char *) str) {
+    return NULL;
+  }
+
   int len = strlen(str) + 1;
   char *buf = malloc(len);
-  if (buf) memcpy(buf, str, len);
+
+  if (buf) {
+    memset(buf, 0, len);
+    memcpy(buf, str, len - 1);
+  }
   return buf;
 }
 
+#endif
+
 #endif /* HAVE_STRDUP */
diff --git a/deps/strdup/strdup.h b/deps/strdup/strdup.h
index 1566205..cd75dd9 100644
--- a/deps/strdup/strdup.h
+++ b/deps/strdup/strdup.h
@@ -18,7 +18,9 @@
  * copy of `str`, or `NULL` on failure.
  */
 
+#ifndef strdup
 char *
 strdup(const char *str);
+#endif
 
 #endif /* HAVE_STRDUP */
diff --git a/deps/which/clib.json b/deps/which/clib.json
new file mode 100644
index 0000000..e8044fd
--- /dev/null
+++ b/deps/which/clib.json
@@ -0,0 +1,15 @@
+{
+  "name": "which",
+  "version": "0.1.3",
+  "repo": "clibs/which",
+  "description": "Locate executable via PATH or given string",
+  "keywords": ["lookup", "which", "locate", "find", "path", "bin", "executable"],
+  "license": "MIT",
+  "src": ["src/which.c", "src/which.h"],
+  "dependencies": {
+    "strdup": "0.0.0"
+  },
+  "development": {
+    "stephenmathieson/describe.h": "1.0.0"
+  }
+}
diff --git a/deps/wildcardcmp/clib.json b/deps/wildcardcmp/clib.json
new file mode 100644
index 0000000..5dd15bf
--- /dev/null
+++ b/deps/wildcardcmp/clib.json
@@ -0,0 +1,9 @@
+{
+  "name": "wildcardcmp",
+  "version": "0.0.0",
+  "repo": "clibs/wildcardcmp",
+  "description": "simple wildcard string comparison",
+  "keywords": ["wildcard", "string", "comparison"],
+  "license": "MIT",
+  "src": ["wildcardcmp.c", "wildcardcmp.h"]
+}
diff --git a/src/clib-build.c b/src/clib-build.c
index 14197dd..6b1a254 100644
--- a/src/clib-build.c
+++ b/src/clib-build.c
@@ -28,7 +28,7 @@
 #endif
 
 #include "common/clib-package.h"
-#include <clib-cache/cache.h>
+#include "common/clib-cache.h"
 
 #include <str-flatten/str-flatten.h>
 #include <commander/commander.h>
diff --git a/src/clib-configure.c b/src/clib-configure.c
index b35df87..b66bcc5 100644
--- a/src/clib-configure.c
+++ b/src/clib-configure.c
@@ -28,7 +28,7 @@
 #endif
 
 #include "common/clib-package.h"
-#include <clib-cache/cache.h>
+#include "common/clib-cache.h"
 
 #include <str-flatten/str-flatten.h>
 #include <commander/commander.h>
diff --git a/src/clib-install.c b/src/clib-install.c
index 3115d25..93f8641 100644
--- a/src/clib-install.c
+++ b/src/clib-install.c
@@ -15,7 +15,7 @@
 #include "fs/fs.h"
 #include "commander/commander.h"
 #include "common/clib-package.h"
-#include "clib-cache/cache.h"
+#include "common/clib-cache.h"
 #include "http-get/http-get.h"
 #include "logger/logger.h"
 #include "debug/debug.h"
diff --git a/src/clib-search.c b/src/clib-search.c
index c34e45c..14cac33 100644
--- a/src/clib-search.c
+++ b/src/clib-search.c
@@ -23,7 +23,7 @@
 #include "logger/logger.h"
 #include "debug/debug.h"
 #include "version.h"
-#include "clib-cache/cache.h"
+#include "common/clib-cache.h"
 #include "parson/parson.h"
 
 #define CLIB_WIKI_URL "https://github.com/clibs/clib/wiki/Packages"
diff --git a/src/clib-update.c b/src/clib-update.c
index 8a70df4..c6ba81c 100644
--- a/src/clib-update.c
+++ b/src/clib-update.c
@@ -15,7 +15,7 @@
 #include "fs/fs.h"
 #include "commander/commander.h"
 #include "common/clib-package.h"
-#include "clib-cache/cache.h"
+#include "common/clib-cache.h"
 #include "http-get/http-get.h"
 #include "logger/logger.h"
 #include "debug/debug.h"
diff --git a/src/clib-upgrade.c b/src/clib-upgrade.c
index eec1b59..507a910 100644
--- a/src/clib-upgrade.c
+++ b/src/clib-upgrade.c
@@ -16,7 +16,7 @@
 #include "fs/fs.h"
 #include "commander/commander.h"
 #include "common/clib-package.h"
-#include "clib-cache/cache.h"
+#include "common/clib-cache.h"
 #include "http-get/http-get.h"
 #include "logger/logger.h"
 #include "debug/debug.h"
diff --git a/deps/clib-cache/cache.c b/src/common/clib-cache.c
similarity index 99%
rename from deps/clib-cache/cache.c
rename to src/common/clib-cache.c
index 5c85717..a09a3a1 100644
--- a/deps/clib-cache/cache.c
+++ b/src/common/clib-cache.c
@@ -6,7 +6,7 @@
 #include "rimraf/rimraf.h"
 #include "fs/fs.h"
 #include "copy/copy.h"
-#include "cache.h"
+#include "clib-cache.h"
 
 
 #define GET_PKG_CACHE(a, n, v) char pkg_cache[BUFSIZ]; \
diff --git a/deps/clib-cache/cache.h b/src/common/clib-cache.h
similarity index 100%
rename from deps/clib-cache/cache.h
rename to src/common/clib-cache.h
diff --git a/src/common/clib-package.c b/src/common/clib-package.c
index 0126fac..2f0b758 100644
--- a/src/common/clib-package.c
+++ b/src/common/clib-package.c
@@ -29,7 +29,7 @@
 #include "parse-repo/parse-repo.h"
 #include "debug/debug.h"
 #include "clib-package.h"
-#include "clib-cache/cache.h"
+#include "clib-cache.h"
 #include "fs/fs.h"
 #include "hash/hash.h"
 
diff --git a/test.sh b/test.sh
index 735bced..3e002f9 100755
--- a/test.sh
+++ b/test.sh
@@ -27,5 +27,13 @@ fi
 
 cd ../../
 
+printf "\nRunning clib cache tests\n\n"
+cd test/cache 
+
+if ! make test; then
+    EXIT_CODE=1
+fi
+
+cd ../../
 
 exit $EXIT_CODE
diff --git a/test/cache/Makefile b/test/cache/Makefile
new file mode 100644
index 0000000..656fbef
--- /dev/null
+++ b/test/cache/Makefile
@@ -0,0 +1,35 @@
+CC ?= cc
+VALGRIND ?= valgrind
+TEST_RUNNER ?=
+
+SRC = ../../src/common/clib-cache.c
+DEPS += $(wildcard ../../deps/*/*.c)
+OBJS = $(SRC:.c=.o) $(DEPS:.c=.o)
+TEST_SRC = $(wildcard *.c)
+TEST_OBJ = $(TEST_SRC:.c=.o)
+TEST_BIN = $(TEST_SRC:.c=)
+
+CFLAGS += -std=c99 -Wall -I../../src/common -I../../deps  -g
+LDFLAGS = -lcurl
+VALGRIND_OPTS ?= --leak-check=full --error-exitcode=3
+
+.DEFAULT_GOAL := test
+
+test: $(TEST_BIN)
+	$(foreach t, $^, $(TEST_RUNNER) ./$(t) || exit 1;)
+
+valgrind: TEST_RUNNER=$(VALGRIND) $(VALGRIND_OPTS)
+valgrind: test
+
+example: example.o $(OBJS)
+
+cache-%: cache-%.o $(OBJS)
+	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)
+
+clean:
+	rm -f $(OBJS)
+	rm -f $(TEST_OBJ)
+	rm -f $(TEST_BIN)
+	rm -rf test/fixtures
+
+.PHONY: test valgrind clean
diff --git a/test/cache/cache-test.c b/test/cache/cache-test.c
new file mode 100644
index 0000000..462169d
--- /dev/null
+++ b/test/cache/cache-test.c
@@ -0,0 +1,97 @@
+#include <stdlib.h>
+#include <limits.h>
+#include <string.h>
+#include <describe/describe.h>
+#include "rimraf/rimraf.h"
+#include "fs/fs.h"
+#include "../../src/common/clib-cache.h"
+
+
+#define assert_exists(f) assert_equal(0, fs_exists(f));
+
+static void assert_cached_dir(char *pkg_dir, int exists)
+{
+    assert_equal(exists, fs_exists(pkg_dir));
+}
+
+static void assert_cached_file(char *pkg_dir, char *file)
+{
+    char path[BUFSIZ];
+    sprintf(path, "%s/%s", pkg_dir, file);
+
+    assert_exists(path);
+}
+
+static void assert_cached_files(char *pkg_dir)
+{
+    assert_cached_file(pkg_dir, "copy.c");
+    assert_cached_file(pkg_dir, "copy.h");
+    assert_cached_file(pkg_dir, "package.json");
+}
+
+int
+main() {
+
+  rimraf(clib_cache_dir());
+
+  describe("clib-cache opearions") {
+
+
+    char *author = "author";
+    char *name = "pkg";
+    char *version = "1.2.0";
+    char pkg_dir[BUFSIZ];
+
+
+    it("should initialize succesfully") {
+      assert_equal(0, clib_cache_init(1));
+    }
+
+    sprintf(pkg_dir, "%s/author_pkg_1.2.0", clib_cache_dir());
+
+    it("should manage package the cache") {
+      assert_equal(0, clib_cache_save_package(author, name, version, "../../deps/copy"));
+      assert_equal(1, clib_cache_has_package(author, name, version));
+      assert_equal(0, clib_cache_is_expired_package(author, name, version));
+
+      assert_cached_dir(pkg_dir, 0);
+      assert_cached_files(pkg_dir);
+    }
+
+    it("should manage the json cache") {
+      char *cached_json;
+
+      assert_equal(0, clib_cache_has_json("a", "n", "v"));
+      assert_null(clib_cache_read_json("a", "n", "v"));
+
+      assert_equal(2, clib_cache_save_json("a", "n", "v", "{}"));
+      assert_equal(0, strcmp("{}", cached_json = clib_cache_read_json("a", "n", "v")));
+      free(cached_json);
+      assert_equal(1, clib_cache_has_json("a", "n", "v"));
+
+      assert_equal(0, clib_cache_delete_json("a", "n", "v"));
+      assert_equal(0, clib_cache_has_json("a", "n", "v"));
+      assert_null(clib_cache_read_json("a", "n", "v"));
+    }
+
+    it("should manage the search cache") {
+      char *cached_search;
+
+  clib_cache_delete_search();
+
+      assert_equal(0, clib_cache_has_search());
+      assert_null(clib_cache_read_search());
+
+      assert_equal(13, clib_cache_save_search("<html></html>"));
+      assert_equal(1, clib_cache_has_search());
+      assert_equal(0, strcmp("<html></html>", cached_search = clib_cache_read_search()));
+      free(cached_search);
+
+      assert_equal(0, clib_cache_delete_search());
+      assert_equal(0, clib_cache_has_search());
+      assert_null(clib_cache_read_search());
+    }
+  }
+
+  return assert_failures();
+}
